package com.zheng.demo.sbtest.demo.rest;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.get;
import static org.springframework.test.web.servlet.result.MockMvcResultHandlers.print;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.web.servlet.MockMvc;

import com.google.gson.Gson;
import com.zheng.demo.sbtest.demo.data.RestReturnData;

@SpringBootTest
@AutoConfigureMockMvc
class TestMockMvcViaGson {

	@Autowired
	private MockMvc mockMvc;

	@Test
	void use_Gson_to_map_JsonString() {
		try {
			String resultString = mockMvc.perform(get("/").param("input", "test_user")).andDo(print())
					.andExpect(status().isOk()).andReturn().getResponse().getContentAsString();
			Gson gson = new Gson();
			RestReturnData someClass = gson.fromJson(resultString, RestReturnData.class);
			assertEquals("test_user", someClass.getSomeString());
			assertEquals(9, someClass.getSomeNumber());
			assertEquals(27, someClass.getSomeIntArray()[8]);

		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
